# zitrlp-netinfo
	
####
1. [Module Description](#module-description)
1. [Setup](#setup)
    1. [Required Modules](#required-modules)
    1. [Required Hiera Keys](#required-hiera-keys)
1. [Usage](#usage)
    1. [Keys in `netinfo` Hiera and Their Sources](#keys-in-netinfo-hiera-and-their-sources)
	1. [Utility Functions](#utility-functions)
1. [Limitations](#limitations)
1. [Development](#development)

## Module Description
`netinfo` supplies a central source of network related information for several modules developed at ZIT-RLP.
Additionally, some utility functions are supplied.

## Setup

### Required Modules
`clusterinfo` needs those modules:
* puppetlabs-stdlib
* zitrlp-netinfo (similar module concerning network config)
The module accesses hiera data of other modules. The modules don't have to be installed, but the keys named in the 
corresponding `clusterinfo` key must be filled in order to get data from `clusterinfo`.

### Required Hiera Keys

## Usage
`clusterinfo` works by collecting keys in all layers up to the cluster itself and constructing keys in the `clusterinfo` namespace from them.
### Keys

### Keys in `netinfo` Hiera and Their Sources

#### netinfo::dns::NS

**Data Structure**: Array

**Input Keys**:
* node config files

**Transformation**:
Iterate over all node config files, add any node matching `^adm-dns'.

#### netinfo::dns::forward
**Data Structure**:

**Input Keys**:
* 

**Transformation**:

#### netinfo::dns::reverse

**Data Structure**:

**Input Keys**:
* 

**Transformation**:


#### netinfo::db_servers

**Data Structure**: Array

**Input Keys**:
* node config files

**Transformation**: Iterate over all node config files, add the first IPv6 address of any node matching `(/[a-z]{2,3}-itf-\w{6}-app-imex-01/=~node) || (/[a-z]{2,3}-[a-z]{3}-([a-z]{4,7}-|)dbs-[0-9]{2}/=~node) || (/adm-dbs-[0-9]{2}/=~node)`.

#### netinfo::nat64_mapping
**Data Structure**: Hash
```
{
	$hostname => {
		$mapped_ipv4_address => $primary_ipv6_address
	}
}
```
**Input Keys**:
* network::nat64_id
* network::nat64::ipv4_prefix

**Transformation**:
Iterate over all nodes, if `network::nat64_id` ist set, generate mapped IPv4 address (i.e. use base address of
`network::nat64::ipv4_prefix` and add `network::nat64_id`, keeping a valid IPv4 address format) and get the
first address from the node's AAAA record.

#### netinfo::nat64_ipv4_prefix
**Data Structure**:

**Input Keys**:
* 

**Transformation**:

#### netinfo::dns64_views
**Data Structure**:

**Input Keys**:
* 

**Transformation**:


### Utility Functions
#### netinfo::extend_ipv6
#### netinfo::get_prefix
#### netinfo::reduce_ipv6
#### netinfo::validate_ipv6

## Limitations
* The module is only tested agains ZIT-RLP's ENC, available at <https://software.service.zit-rlp.de>.
* Parts of the module may work even without strictly following the naming scheme, 
  for full functuallity, the naming scheme must be applied.
