Puppet::Functions.create_function(:'netinfo::extend_ipv6') do
	dispatch :extend_ipv6 do
		param 'String', :name
	end

	def extend_ipv6(prefix)
		if(!call_function('netinfo::validate_ipv6',prefix))
			return nil
		end
		s=prefix.split('/')
		addr=s[0]
		if(s.size==2)
			len=s[1].to_i
		else
			len=128
		end
		if(/::[a-fA-F0-9]/.match?(addr))
			#compressed address, replace :: with 0000-blocks
			res=''
			p=addr.split(':')
			if(p.size<7)
				for i in 0..(p.size-1)
					part=p[i]
					if(part.empty?)
						for j in p.size..8
							res+="0000:"
						end
					else
						res+=part+":"
					end
				end
				addr=res
			end
		end
		#fill all blocks to contain four chars
		p=addr.split(':')
		addr=''
		for i in 0..(p.size-1)
			part=p[i]
			for j in part.size..3
				part="0#{part}"
			end
			addr+=part+":"
		end
		for i in p.size..7
			addr+='0000:'
		end
		"#{addr[0,addr.size-1]}/#{len}"
	end
end
