Puppet::Functions.create_function(:'netinfo::get_pg_hba_type') do
  dispatch :get_pg_hba_type do
    param 'String', :net
  end

  def get_pg_hba_type(net)
      rules=call_function("lookup","network::net_pg_encryption")
      while(rule=pop_rule(rules))
          if(!rule.has_key?('pattern'))
              fail("clusterinfo: network::net_pg_encryption[#{rule['name']}] does not have a pattern attribute")
          end
          if(!rule.has_key?('ssl'))
              fail("clusterinfo: network::net_pg_encryption[#{rule['name']}] does not have a ssl attribute")
          end
          pattern=rule['pattern'].downcase
          if(/#{pattern}/=~net.downcase)
              if(rule['ssl'])
                  return('hostssl')
              else
                  return('host')
              end
          end
      end
      fail("clusterinfo: network::net_pg_encryption did not contain an entry matching #{net}")
  end

  def pop_rule(rules)
      last_prio=-1
      rule_key=''
      rules.each do|rule,data|
          if(!data.key?('priority'))
              fail("clusterinfo: network::net_pg_encryption[#{rule}] does not have a priority")
          end
          if (data['priority'].to_i>last_prio)
              last_prio=data['priority'].to_i
              rule_key=rule.to_s
          end
      end
      if(!rule_key.empty?)
          rule=rules[rule_key]
          rule['name']=rule_key
          rules.delete(rule_key)
          rule
      else
          nil
      end
  end
end
