def extend_ipv6(prefix)
	if(!validate_ipv6(prefix))
		return nil
	end
	s=prefix.split('/')
	addr=s[0]
	if(s.size==2)
		len=s[1].to_i
	else
		len=128
	end
	if(/::[a-fA-F0-9]/.match?(addr))
		#compressed address, replace :: with 0000-blocks
		res=''
		p=addr.split(':')
		if(p.size<7)
			for i in 0..(p.size-1)
				part=p[i]
				if(part.empty?)
					for j in p.size..8
						res+="0000:"
					end
				else
					res+=part+":"
				end
			end
			addr=res
		end
	end
	#fill all blocks to contain four chars
	p=addr.split(':')
	addr=''
	for i in 0..(p.size-2)
		part=p[i]
		for j in part.size..3
			part="0#{part}"
		end
		addr+=part+":"
	end
	addr+=p[p.size-1]
	"#{addr}/#{len}"
end

def reduce_ipv6(prefix)
	if(!validate_ipv6(prefix))
		return nil
	end
	s=prefix.split('/')
	addr=s[0]
	if(s.size==2)
		len=s[1].to_i
	else
		len=128
	end
	res=""
	counter=8
	compressed=/::[a-fA-F0-9]/.match?(addr)
	compressing=false
	addr_parts=addr.split(':').reverse
	if(compressed)
		ignored_blocks=len/16
		for i in 0..ignored_blocks-1 do
			if addr_parts[i].empty?
				# :: in ignored blocks, fill with 0 entries
				left=addr_parts[0,i]
				right=addr_parts[i+1,addr_parts.size]
				pad=[]
				for j in (left.size+right.size+1)..8
					pad << '0'
				end
				addr_parts=left+pad+right
				compressed=false
				break
			end
		end
	end
	if(/::$/.match?(addr))
		pad=[]
		for j in (addr_parts.size+1)..8
			pad << '0'
		end
		addr_parts=pad+addr_parts
	end
	addr_parts.each do|block|
		counter-=1
		if(counter > (len/16))
			block='0'
		elsif((counter)==(len/16))
			d=(len-(len/16)*16)/4 #number of upper bytes to keep
			b=block.split('')
			#make sure b contains 4 entries, zero-pad upper bytes
			while(b.size<=4)
				b.unshift('0')
			end
			block=""
			#build zero-padded block: upper bytes
			for i in 1..d
				block+=b[i]
			end
			#build zero-padded block: lower byes (set to 0 as they are in the host part of the prefix)
			for i in (d+1)..4
				block+='0'
			end
		end
		if(res.empty?)
			append=''
		else
			append=":#{res}"
		end
		if(block.empty?)
			res=":#{res}";
		else
			block.gsub!(/^0*/,'')
			if(block.empty?)
				block='0'
			end
			if(block=='0')
				if(!compressed)
					if(!compressing) #this part may be compressed and compression has not started yet.
						compressing=true
					end
				else #already compressed, explicitly set 0
					res="0#{append}"
				end
			else
				if(compressing) #this is the first non-empty entry after compression, add it with ::
					res="#{block}::#{res}"
					compressed=true
					compressing=false
				else #this is just a normal block, prepend it
					res="#{block}#{append}"
				end
			end
		end
	end
	res.gsub(/$/,"/#{len}")
end

