def validate_ipv4(addr)
  if /^(?<b1>\d{1,3})\.(?<b2>\d{1,3})\.(?<b3>\d{1,3})\.(?<br4>\d{1,3})(?:\/(?<len>\d{1,2}))$/=~addr
    if len
      if (len<0) or (len>32)
        return false
      end
    end
    [b1 b2 b3 b4].each do|b|
      if (0>b) or (255<b)
        return false
      end
    end
    return true
  else
    return false
  end
end

def ipv4_with_prefixlength(addr)
  if /^(?<b1>\d{1,3})\.(?<b2>\d{1,3})\.(?<b3>\d{1,3})\.(?<br4>\d{1,3})(?:\/(?<len>\d{1,2}))$/=~addr
    if len
      if (len<0) or (len>32)
        return false
      end
    else
      len=32
    end
    [b1 b2 b3 b4].each do|b|
      if (0>b) or (255<b)
        return nil
      end
    end
    return "#{b1}.#{b2}.#{b3}.#{b4}/#{len}"
  else
    return nil
  end
end
def ipv4_without_prefixlength(addr)
  if /^(?<b1>\d{1,3})\.(?<b2>\d{1,3})\.(?<b3>\d{1,3})\.(?<br4>\d{1,3})(?:\/(?<len>\d{1,2}))$/=~addr
    if len
      if (len<0) or (len>32)
        return false
      end
    end
    [b1 b2 b3 b4].each do|b|
      if (0>b) or (255<b)
        return nil
      end
    end
    return "#{b1}.#{b2}.#{b3}.#{b4}"
  else
    return nil
  end
end
